<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="6" class="text-align-left">
                            <h3>Roles</h3>
                        </el-col>
                        <el-col :span="18">
                            <el-row :gutter="20">
                                <el-col :lg="14" :md="14" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Role's name" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getRoles(1, false)" 
                                        @clear="getRoles(1, false)"/>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getRoles(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button size="small" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="roles" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Name"
                        width="200">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Description"
                        width="200">
                        <template slot-scope="scope">
                            <span>{{ scope.row.description }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        align="center"
                        label="Total User"
                        width="150">
                        <template slot-scope="scope">
                            <el-tag type="success">{{ scope.row.total_user }}</el-tag>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'role', 'viewother']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'role', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                            <el-button v-permission="[row, 'permission', 'viewother']" type="text" class="text-info" @click="handlePermission(row)">Permission</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showRoleDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="roleForm" :model="roleForm" :rules="roleRules">
                        <aside>
                            <el-alert type="info" description="Add or edit user role" :closable=false show-icon></el-alert>
                        </aside>
                        <el-form-item label="Name" prop="name">
                            <el-input ref="name" name="name" v-model="roleForm.name" placeholder="Role name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                        </el-form-item>
                        <el-form-item label="Description" prop="description">
                            <el-input ref="description" name="description" v-model="roleForm.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                        </el-form-item> 
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showRoleDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'role', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>

                <el-dialog v-loading="permissionDialogLoading" :title="permissionDialogTitle" :visible.sync="showPermissionDialog" width="80%" :show-close="false">
                    <aside>
                        <el-alert type="info" description="Set the toggle ON for each module to give an access permission to this role" :closable=false show-icon></el-alert>
                    </aside>
                    <el-table :data="permissions" ref="permissionTable" style="width: 100%" fit highlight-current-row>
                        <el-table-column
                            fixed="left"
                            label="Module"
                            width="175">
                            <template slot-scope="{row}">
                                <span style="color:#3E89FA;">{{ row.name }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Menu"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['menu']" @change="handlePermissionChange({'module': row.slug, 'permission': 'menu', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="View All"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewall']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewall', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Create"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['create']" @change="handlePermissionChange({'module': row.slug, 'permission': 'create', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>                
                        <el-table-column
                            align="center"
                            label="View Own"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewown', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="View Other"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewother', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Edit Own"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['editown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'editown', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Edit Other"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['editother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'editother', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Delete Own"
                            width="100">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['deleteown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'deleteown', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                        <el-table-column
                            align="center"
                            label="Delete Other"
                            width="120">
                            <template slot-scope="{row}">
                                <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['deleteother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'deleteother', 'value': $event})"></el-switch>
                            </template>
                        </el-table-column>
                    </el-table>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showPermissionDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Close</el-button>
                        <el-button v-permission="[null, 'role', 'editown']" @click="handleSubmitPermission" size="medium" type="success"><i class="ion-ios-checkmark-circle"></i> Save Permission</el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight } from '../../utils/index';
export default {
    name: 'Roles',
    directives: {
        permission
    },
    data(){
        return{
            tableLoading: false,
            dialogLoading: false,
            permissionDialogLoading: false,
            showRoleDialog: false,
            showPermissionDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit Role',
                add: 'Add New Role'
            },
            permissionDialogTitle: '',
            currentRole: null,
            filter: {
                keyword: ''
            },
            roleForm: {
                id: null,
                name: '',
                description: ''
            },
            roleRules: {
                name: [{ 
                    required: true, message: 'Role name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Role name length 255 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z\s]{1,255})$/, 
                    message: 'Only letters and spaces are allowed.', 
                    trigger: 'blur'
                }],
                description: [{ 
                    max: 255, 
                    message: 'Description length maximum 255 characters', 
                    trigger: 'blur'
                }]
            },
        }
    },
    computed:{
        ...mapGetters('user', ['me']),
        ...mapGetters('role', [
            'permissions',
            'roles',
            'pagination'
        ]),
        defaultPermissions: {
            get(){
                return this.$store.getters['role/defaultPermissions'];
            },
            set(){
                return;
            }
        }
    },
    created(){
        const self = this;
        self.getPermissions();
        self.getRoles();
    },
    methods: {
        dateFormat,
        tableHeight,
        getPermissions() {
            this.tableLoading = true;
            this.$store.dispatch('role/getAllPermissions', {
                page: 1,
                perpage: 25
            });
        },
        getRoles(page, loadmore) {
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            self.$store.dispatch('role/getAllRoles', params).then(()=>{
                self.tableLoading = false;
            });

        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getRoles(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showRoleDialog = true;          
            self.$nextTick(() => {
                self.$refs['roleForm'].clearValidate();
            });
        },
        handleEdit(role){
            const self = this;
            self.dialogStatus = 'edit';
            self.showRoleDialog = true;

            self.roleForm.id = role.id;
            self.roleForm.name = role.name;
            self.roleForm.description = role.description;

            self.$nextTick(() => {
                this.$refs['roleForm'].clearValidate();
            });
        },
        handleDelete(role){
            const self = this;

            self.$confirm('You are about to delete this role. This operation will affecting some users lost their access to this application. All users registered to this role will be transfered to the "orphan" role and this operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('role/deleteRole', {
                    id: role.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.roleForm.validate((valid)=>{
                if(valid){
                    self.dialogLoading = true;

                    let action = 'role/addRole';
                    let params = {
                        name: self.roleForm.name,
                        description: self.roleForm.description
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'role/editRole';
                        params.id = self.roleForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showRoleDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        handlePermission(role){
            const self = this;

            self.currentRole = role;
            self.permissionTitle = role.name + ' Permissions';
            self.showPermissionDialog = true;
            self.defaultPermissions = Object.assign(self.defaultPermissions, role.permissions);
        },
        handlePermissionChange(payload){
            const self = this;
            self.$store.dispatch('role/updateDefaultPermission', payload);
        },
        handleSubmitPermission(){
            const self = this;

            self.permissionDialogLoading = true;

            self.$store.dispatch('role/editRolePermission', {
                id: self.currentRole.id,
                permissions: self.defaultPermissions
            }).then((response) => {

                self.permissionDialogLoading = false;

                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    self.showPermissionDialog = false;
                    self.$message.success({
                        message: response.message
                    });
                }
            });
        },
        resetForm() {
            const self = this;

            self.roleForm = {
                id: null,
                name: '',
                description: ''
            };
        },
    }
}
</script>